
// var tinymce = document.getElementById('textarea') 

var plat = "Pc",
    height = 'calc(100vh - 46px)'
    , ios_version = 12
var focusnum = 0
function checkPlatform() {


    if (/android/i.test(navigator.userAgent)) {
        plat = 'android'
        // document.getElementById('Editor_box').addEventListener('scroll', (e) => {
        //     console.log(e)
        //     e.preventDefault()
        //     e.stopPropagation()
        // })
    }
    if (/(iPhone|iPad|iPod|iOS|Mac)/i.test(navigator.userAgent)) {
        plat = "IOS"
        height = window.innerHeight - 46
        var reg = /os [\d._]*/gi;
        var verinfo = navigator.userAgent.toLowerCase().match(reg);
        ios_version = (verinfo + "").replace(/[^0-9|_.]/ig, "").replace(/_/ig, ".").split('.')[0];
    }
    if (/MicroMessenger/i.test(navigator.userAgent)) {
        plat = "wx"
    }
};

var Re = {
    focusType: '',
    height: '',
    keyboarheight: 450,
    editors: '',
    Edtor: '',
    composition: false,
    w_h: window.innerHeight,
    schemeCache: {
        FOCUS_SCHEME: 'focus://',
        CHANGE_SCHEME: 'change://',
        STATE_SCHEME: 'state://',
        CALLBACK_SCHEME: 'callback://',
        IMAGE_SCHEME: 'image://'
    },
    currentRange: {
        startContainer: null,
        startOffset: 0,
        endContainer: null,
        endOffset: 0
    },

    /**
     * 保存论文
     */
    saveWritingData() {
        clearTimeout(this.times)
        this.times = setTimeout(() => {
            this.getEditItem()
            console.log('保存中')
            var writing = this.getHtml()
            var WritingTitle = document.getElementById('W_title').value
            if (plat == "android") {
                //这里调用android暴露出来对方法
                window.androidJs.onTextChange(WritingTitle, writing)
            }
            if (plat == "IOS") {
                //这里调用IOS里面暴露出来对方法 
                window.webkit.messageHandlers.onTextChange.postMessage(WritingTitle + '$title_connect_body$' + writing);
            }
        }, 1000);
    },
    time_content: "",



    // 设置论文标题
    setWritingTitle(title) {
        // this.saveWritingData()
        document.getElementById('W_title').value = title || ''
    },
    /**
     * 保存节点
     * 
     * */
    saveRange: function saveRange() {
        //保存节点位置
        var _self = this;
        var selection = this.editors.document.getSelection();
        // console.log(selection)
        if (selection.rangeCount > 0) {
            var range = selection.getRangeAt(0);
            var startContainer = range.startContainer,
                startOffset = range.startOffset,
                endContainer = range.endContainer,
                endOffset = range.endOffset;
            _self.currentRange = {
                startContainer: startContainer,
                startOffset: startOffset,
                endContainer: endContainer,
                endOffset: endOffset
            };

        }
    },
    /**
    * 还原节点
    * 
   */
    reduceRange: function reduceRange() {
        //还原节点位置
        var _self = this;
        var _self$currentRange = _self.currentRange,
            startContainer = _self$currentRange.startContainer,
            startOffset = _self$currentRange.startOffset,
            endContainer = _self$currentRange.endContainer,
            endOffset = _self$currentRange.endOffset;
        var range = this.editors.document.createRange();
        if (!_self.currentRange) {
            return false
        }

        var selection = this.editors.document.getSelection();
        selection.removeAllRanges();
        range.setStart(startContainer, startOffset);
        range.setEnd(endContainer, endOffset);
        selection.addRange(range);
        this.onFocusContent()
        this.focus()
    },
    //通知移动端内容激活
    onFocusContent() {
        clearTimeout(this.time_content)
        setTimeout(() => {
            if (plat == "android") {
                //这里调用android暴露出来对方法
                window.androidJs.onFocusContent('编辑器窗口激活了')
            }
            if (plat == "IOS") {
                //这里调用IOS里面暴露出来对方法 
                window.webkit.messageHandlers.onFocusContent.postMessage('编辑器窗口激活了');
            }
        }, 400);
    },
    adinit() {
        // document.body.addEventListener("click", (e) => {
        //     e.preventDefault();
        // })
        tinymce.init({
            selector: 'textarea',
            placeholder: '在这里输入文字',
            // height: height,
            min_height: window.innerHeight - 76,
            max_width: window.innerWidth,
            autoresize_on_init: true,
            remove_trailing_brs: false,
            br_in_pre: false, //取消br标签
            branding: false, //关闭tinymce技术支持文案显示
            elementpath: false, //关闭下方标签显示
            //inline: true, //内联模式
            toolbar: false, //隐藏工具栏
            menubar: false, //隐藏菜单栏
            Captions: false, //题注开关 
            fix_list_elements: true,
            plugins: "lists,advlist,autoresize,searchreplace,table,noneditable",
            lastServerUpdateTime: "",
            entity_encoding: 'named',
            lists_indent_on_tab: false,
            automatic_uploads: false,
            tabmouse: false,
            image_description: false,
            link_title: false,
            noneditable_noneditable_class: "mceNonEditable",
            forced_root_block: 'p',
            forced_root_block_attrs: {
                'divContent': "divContent",
            },
            extended_valid_elements: 'p[divContent=divContent]',
            content_style: "img {max-width:100%;}",
            images_dataimg_filter: function (img) {
                return img.hasAttribute("internal-blob");
            },
            image_advtab: true,
            images_reuse_filename: true,
            allow_html_in_named_anchor: true,
            formats: {
                bold: {
                    inline: "strong",
                    attributes: { "data-style": "bold" },
                    exact: false,
                },
                p: { block: 'p', attributes: { "divContent": "divContent" }, },
                insertImage: { block: "img", class: ['imgage'], styles: { "max-width": "100%", 'min-width': '100%', 'min-height': '20px' } },

                strikethrough: [
                    {
                        inline: "span",
                        styles: {
                            textDecoration: "line-through",
                        },
                        exact: false,
                    },
                ],
                underline: [
                    {
                        inline: "u",
                        styles: {
                            textDecoration: "underline",
                        },
                        exact: false,
                    },
                ],
            },
            mobile: {
                menubar: false,
                plugins: 'lists,advlist,autoresize,searchreplace,table,noneditable',
                toolbar: '',
            },
            times: '',
            initTimes: '',
            saveTime: '',
            init_instance_callback: (editor) => {
                this.Edtor = editor
                window.onresize = function (e) {
                }
                this.editors = document.getElementById("textarea_ifr").contentWindow
                var mate = document.createElement('mate')
                mate.setAttribute('name', 'viewport')
                mate.setAttribute('content', 'width=device-width, initial-scale=1, maximum-scale=1, minimum-scale=1, user-scalable=no')
                this.editors.document.head.append(mate)
                setTimeout(() => {
                    // Re.addHtml()
                    this.initListener()
                    //     setTimeout(() => {
                    //         Re.clearUndoManager()
                    //     }, 100);

                    this.setEditorHtight()

                }, 500);
                setTimeout(() => {
                    this.initListener()
                }, 1000)

                if (plat == "android") {
                    //这里调用android暴露出来对方法
                    window.androidJs.editorLoadComplete('加载完成')
                }
                if (plat == "IOS") {
                    //这里调用IOS里面暴露出来对方法 
                    this.blur()
                    window.webkit.messageHandlers.editorLoadComplete.postMessage('加载完成');
                }

            },
        });
    },
    title_focus() {
        document.getElementById('W_title').focus()
    },

    moustitle() {
        this.focusType = 'title'
        if (plat == "android") {
            //这里调用android暴露出来对方法
            window.androidJs.onFocusTitle('标题窗口激活了')
        }
        if (plat == "IOS") {
            //这里调用IOS里面暴露出来对方法 
            window.webkit.messageHandlers.onFocusTitle.postMessage('标题窗口激活了');
        }
    },
    // onFocusContent(){},
    pasteTime: '',
    //添加事件监听
    initListener() {
        this.editors.document.getElementById('tinymce').addEventListener("click", (e) => {
            this.focusType = 'editor'
            if (plat == "android") {
                //这里调用android暴露出来对方法
                window.androidJs.onFocusContent('编辑器窗口激活了')
            }
            if (plat == "IOS") {
                //这里调用android暴露出来对方法
                let top = document.body.scrollTop

                //                if (focusnum == 0) {
                window.webkit.messageHandlers.onFocusContent.postMessage('编辑器窗口激活了');
                //                    focusnum += 1
                //                setTimeout(()=>{
                //                    document.body.scrollTop=top
                //                },300)
                //                }

            }
            // if (plat == "IOS") {
            //     //这里调用IOS里面暴露出来对方法 
            //     window.webkit.messageHandlers.onFocusContent.postMessage('编辑器窗口激活了');
            // }
            // if (this.editors.document.getElementById('tinymce').innerText == '') {
            //     this.editors.document.getElementById('tinymce').innerHTML == '<p><br></p>'
            // }
        })

        this.editors.document.getElementById('tinymce').addEventListener("touchstart", (e) => {
            clearTimeout(this.initTimes)
            this.initTimes = setTimeout(() => {
                this.getEditItem()
                this.saveWritingData()
            }, 300);
        })
        this.editors.document.getElementById('tinymce').addEventListener("paste", (e) => {
           

            clearTimeout(this.pasteTime)
            if(plat=="android"){
                return false
            }else{
                e.preventDefault();
            }
            if (e.clipboardData || e.originalEvent) {
                var clipboardData = e.clipboardData || window.clipboardData;
                if (!clipboardData.types.includes("Files")) {
                    var val =
                        clipboardData.getData("text/html") ||
                        clipboardData.getData("text");
                    var span = document.createElement('span')
                    span.innerHTML = val

                    this.pasteTime = setTimeout(() => {
                        this.Edtor.execCommand('insertHTML', false, span.innerHTML);
                    }, 10)
                }
            }


        })
        var heihtj = ''
        this.editors.document.getElementById('tinymce').addEventListener("input", () => {
            clearTimeout(this.saveTime)
            this.getEditItem()
            clearTimeout(heihtj)
            this.saveTime = setTimeout(() => {
                this.saveWritingData()
                if (!this.composition && this.editors.document.getSelection().isCollapsed && this.editors.document.getSelection().getRangeAt(0).startOffset > 1) {
                    this.Edtor.insertContent(``);
                    tinymce.activeEditor.undoManager.add()
                }
            }, 1);
            //if (plat == "IOS") {
            heihtj = setTimeout(() => {
                this.scrollTop_y()
                this.setEditorHtight()
            }, 10);
            //}

        })

        this.editors.document.getElementById('tinymce').addEventListener("focusin", (e) => {


        })
        this.editors.document.getElementById('tinymce').addEventListener("focus", (e) => {
            clearTimeout(this.initTimes)
            this.focusType = 'editor'
            if (plat == "IOS") {
                //这里调用IOS里面暴露出来对方法 
                window.webkit.messageHandlers.onFocusContent.postMessage('编辑器窗口激活了');
            }
            if (plat == "android") {
                //这里调用android暴露出来对方法
                if (focusnum == 0) {
                    window.androidJs.onFocusContent('编辑器窗口激活了')
                    focusnum += 1
                }

            }
            this.initTimes = setTimeout(() => {
                this.getEditItem()
            }, 300);
        })

        this.editors.document.getElementById('tinymce').addEventListener("compositionstart", () => {

            this.composition = true
        })

        this.editors.document.getElementById('tinymce').addEventListener("compositionend", () => {

            this.composition = false

        })
        key_enter = ""
        this.editors.document.getElementById('tinymce').addEventListener("keyup", e => {
            //document.getElementById('Editor_box').style.height = document.getElementsByClassName('tox-tinymce')[0].clientHeight - 160 + 'px'
            document.documentElement.scrollTop = document.documentElement.scrollTop
            document.body.scrollTop = document.body.scrollTop
            e.preventDefault()
            if (e.keyCode == 32) {
                // tinymce.activeEditor.insertContent('&#65279')
            }
            clearTimeout(this.key_enter)
            if (e.keyCode == '13') {
                this.key_enter = setTimeout(() => {
                    this.scrollTop_y()
                }, 1)

            }
            this.initTimes = setTimeout(() => {
                this.getEditItem()

            }, 300);
        })
    },
    setEditorHtight(num) {
        document.getElementById('Editor_box').setAttribute('style', 'height:' + document.getElementsByClassName('tox-tinymce')[0].clientHeight + 'px;min-height:' + window.innerHeight + 'px;cursor-spacing:100;-webkit-overflow-scrolling: touch')
    },
    setType() {
        this.focusType = "title"
    },
    setScrollnub(num, num1) {
        console.log(num1)
        this.setEditorHtight()
        //        if (document.getElementsByClassName('tox-tinymce')[0].clientHeight > window.innerHeight) {
        //            document.documentElement.style.marginBottom = 69 + (num1 - 0) + "px"
        //            document.body.style.marginBottom = 69 + (num1 - 0) + "px"
        //        } else {
        document.documentElement.style.marginBottom = (num1 - 0) + "px"
        document.body.style.marginBottom = (num1 - 0) + "px"
        //        }

        //       document.documentElement.scrollTop = document.documentElement.scrollTop +this.keyboarheight-(num1-0)
        //       document.body.scrollTop = document.body.scrollTop+this.keyboarheight-(num1-0)
        this.keyboarheight = num - 0
        this.scrollTop_y()
    },
    scrollTop_y() {

        console.log(this.focusType)
        if (this.focusType == "title") {
            return false
        }
        var range = this.editors.document.getSelection().getRangeAt(0);
        var span = document.createElement("span");
        range.insertNode(span);
        window.getSelection().removeAllRanges();
        let top = span.getBoundingClientRect().top
        span.remove()
        if (top < 200) {
            return false
        }
        if (plat == "IOS") {

            document.documentElement.scrollTop = top - (this.w_h - this.keyboarheight) * 0.5 + tinymce.activeEditor.queryCommandValue("fontSize").split('px')[0] * 1.1
            document.body.scrollTop = top - (this.w_h - this.keyboarheight) * 0.5 + tinymce.activeEditor.queryCommandValue("fontSize").split('px')[0] * 1.1
        } else {
            document.documentElement.scrollTop = top - (this.w_h - this.keyboarheight) * 0.5 + tinymce.activeEditor.queryCommandValue("fontSize").split('px')[0] * 1.1
            document.body.scrollTop = top - (this.w_h - this.keyboarheight) * 0.5 + tinymce.activeEditor.queryCommandValue("fontSize").split('px')[0] * 1.1
        }


    },
    queryArray: [
        "lineheight", //行间距
        "bold", //粗体
        "italic", //斜体
        "underline", //下划线
        "strikethrough", //删除线
        "justifyLeft", //左对齐
        "justifyCenter", //居中对齐
        "justifyRight", //右对齐
        "justifyFull", //两端对齐
        "foreColor", //文字颜色
        "fontName", //字体名称
        "bullist",
        "numlist",
        "insertUnorderedList", //无序列表
        "insertOrderedList", //有序列表
        "outdent",
        "indent",
        "hiliteColor", //背景颜色
        "blockquote",
        "removeformat",//清空文本样式
        "subscript", //下角标
        "superscript", //上角标
        "h1", //标题
        "h2",
        "h3",
        "h4",
        "h5",
        "h6",
    ],

    /**
     * 
     * @param {*} tag 属性名称 使用下方属性调用这个方法
     *  "bold", //粗体
        "italic", //斜体
        "underline", //下划线
        "strikethrough", //删除线
        "justifyLeft", //左对齐
        "justifyCenter", //居中对齐
        "justifyRight", //右对齐
        "justifyFull", //两端对齐 
        "subscript", //下角标
        "superscript", //上角标
        "undo",//撤销
        "redo",//重做
        "indent",//缩进
        "outdent",//取消缩进
     */
    exec(tag) {
        if (this.editors.document.getSelection().isCollapsed) {
            this.Edtor.insertContent(`&#65279`);
        }
        tinymce.execCommand(tag)
        //        this.saveWritingTitle()
    },
    no_event(event) {
        console.log(event)
        event.stopPropagation()
        event.preventDefault()
        document.documentElement.scrollTop = 0
        document.body.scrollTop = 0
        this.blur()
        document.getElementById('W_title').focus()
    },
    //移动端键盘弹起后设置滚动条位置
    setScrollTop(num) {
        this.keyboarheight = num
        this.setEditorHtight()
        this.scrollTop_y()
    },
    //上角标
    execsup(tag) {
        this.getEditItem()
        if (
            this.editors.document.getSelection().isCollapsed &&
            !this.acvArray.includes("subscript")
        ) {

            this.Edtor.insertContent(`&#65279`);
            tinymce.activeEditor.undoManager.transact(function () {
                tinymce.execCommand('delete');
            });
            this.acvArray.push(tag);
        }
        if (
            this.editors.document.getSelection().isCollapsed &&
            this.acvArray.includes("subscript")
        ) {
            tinymce.execCommand("subscript");
        }
        tinymce.execCommand(tag);
    },
    //下角标
    execsub(tag) {
        this.getEditItem()
        if (
            this.editors.document.getSelection().isCollapsed &&
            !this.acvArray.includes("superscript")
        ) {
            this.Edtor.insertContent(`&#65279`);
            tinymce.activeEditor.undoManager.transact(function () {
                tinymce.execCommand('delete');
            });
            this.acvArray.push(tag);
        }
        if (
            this.editors.document.getSelection().isCollapsed &&
            this.acvArray.includes("superscript")
        ) {
            tinymce.execCommand("superscript");
        }
        tinymce.execCommand(tag);
    },
    /**
     * 设置文字颜色
     * @param {*} item  例:#FFFFFF
     */
    setFontcolor(item) {
        if (this.editors.document.getSelection().isCollapsed) {
            this.Edtor.insertContent(`&#65279`);
        }
        tinymce.execCommand("foreColor", false, item);
    },
    /**
    * 设置字体
    */
    setFamily(val) {
        if (this.editors.document.getSelection().isCollapsed) {
            this.Edtor.insertContent(`&#65279`);
        }
        tinymce.execCommand("fontName", false, val);
    },

    /**
     * 设置行高 例: 1
     */
    execLineheight(val) {
        if (this.editors.document.getSelection().isCollapsed) {
            this.Edtor.insertContent(`&#65279`);
        }
        tinymce.execCommand("lineHeight", false, val);
    },
    /**
      * 设置背景颜色
      * @param {*} item  例:#FFFFFF
      */
    setBgcolor(item) {
        if (this.editors.document.getSelection().isCollapsed) {
            this.Edtor.insertContent(`&#65279`);
        }
        tinymce.execCommand("hiliteColor", false, item);
    },
    //添加图片
    addimage(url) {
        // tinymce.activeEditor.execCommand("mceImage");
        tinymce.execCommand("insertImage", false, url);
        // if (plat == "android") {
        //     //这里调用android暴露出来对方法
        //     this.Edtor.insertContent(``);
        //     this.blur()
        // }
    },
    insertImage(url) {
        if (!this.editors.document.getSelection().isCollapsed) {
            this.Edtor.insertContent(`&#65279`);
        }
        setTimeout(() => {

            tinymce.activeEditor.insertContent(`<img  src='${url}' style='max-width:100%;display: block;margin: 0 auto;' />`)

            // this.editors.document.getElementById('img1').addEventListener('load', e => {
            //     console.log(e.path[0].naturalWidth)
            //     if (e.path[0].naturalWidth > 600) {
            //         e.path[0].setAttribute('style', 'max-width:100%;display: block;margin: 0 auto;')
            //     } else {
            //         e.path[0].setAttribute('style', 'max-width:' + e.path[0].naturalWidth + 'px;display: block;margin: 0 auto;')
            //     }
            //     this.saveWritingData()
            //     e.path[0].removeAttribute('id')
            // })
        }, 300);

    },
    //添加链接
    addlink() {
        tinymce.execCommand("mceLink");
        this.saveWritingData()
    },
    /**
     * 移动端添加链接
     * @param {*} href  url 链接地址
     * @param {*} content  要显示的文本内容 不传默认显示链接地址
     * @param {*} target 打开方式 新窗口打开:_blank  当前窗口打开:_self
     */
    insertLink(href, content, target) {
        let url = href
        if (!href.includes('http') && !href.includes('https')) {
            url = 'https://' + href
        }
        this.Edtor.insertContent(`<a href="${url}" target="${target}" rel="noopener noreferrer">${content == "" ? href : content}</a>`)
    },
    /**
   * 有序无序列表
   * @param {InsertUnorderedList} 无序列表
   * @param {InsertOrderedList} 有序列表
   */
    decimalCommand(type, val) {
        //取消/设置默认样式列表
        tinymce.activeEditor.undoManager.ignore(() => {
            tinymce.execCommand("formatBlock", false, 'p');
        })

        tinymce.execCommand(type, false, {
            "list-item-attributes": {
                class: val,
            },
            "list-attributes": {
                type: val,
            },
        });
        this.saveWritingData()
    },
    addCommand(type, val) {
        //设置各种样式的列表
        tinymce.activeEditor.undoManager.ignore(() => {
            tinymce.execCommand("formatBlock", false, 'p');
        })
        tinymce.execCommand(type, false, {
            "list-style-type": val,
            "list-item-attributes": {
                class: val,
            },
            "list-attributes": {
                id: val,
            },
        });
        this.saveWritingData()
    },

    remlist(type) {
        tinymce.execCommand(type);
    },
    /**
     * 设置标题正文类
     * @param {*}tag 传h1到h6 ,正文传p
     */
    execTitle(tag) {
        if (this.editors.document.getSelection().isCollapsed) {
            this.Edtor.insertContent(`&#65279`);
        }
        // if (plat == 'IOS') {
        //     if (!this.editors.document.getSelection().isCollapsed) {
        //         tinymce.activeEditor.insertContent(`&#65279`);
        //         tinymce.activeEditor.execCommand('delete')
        //         tinymce.activeEditor.undoManager.ignore(function () {

        //             tinymce.activeEditor.undoManager.undo()
        //         })
        //     }
        // }
        tinymce.activeEditor.execCommand("formatBlock", false, tag);
        this.saveWritingData()
    },
    /**
     * 锚点跳转
     */
    jump(id) {
        const downloadEle = this.editors.document.getElementById(id)
        if (downloadEle) {
            downloadEle.scrollIntoView(true) // true 是默认的
        }
        this.editors.document.getElementById('textarea_ifr').scrollIntoView(true)
    },
    /**
     * 插入表格
     * @param {*} row 行 3
     * @param {*} col 列 3
     */
    addTable(row, col) {
        // tinymce.activeEditor.plugins.table.insertTable(row, col);
        tinymce.activeEditor.execCommand("mceInsertTable", false, {
            rows: row,
            columns: col,
        });
        this.saveWritingData()
    },
    /**
     * 设置文字大小
     */
    setFontsize(val) {
        tinymce.execCommand("fontSize", false, val);
    },
    //使编辑器获得焦点
    focus() {
        // this.editors.document.getElementById('tinymce').click()
        tinymce.activeEditor.focus()
    },
    //使编辑器获失去焦点
    blur() {

        this.editors.document.getElementById('tinymce').blur()
    },
    //撤销
    execDo(tag) {
        let top = document.getElementById('Editor_box').scrollTop || 0
        tinymce.activeEditor.undoManager.undo()
        document.getElementById('Editor_box').scrollTop = top
        this.focus()
        this.scrollTop_y()
        this.setEditorHtight()
        this.getEditItem()
    },
    //还原
    execredo(tag) {
        let top = document.getElementById('Editor_box').scrollTop || 0
        tinymce.activeEditor.undoManager.redo()
        // if (this.editors.document.getSelection().isCollapsed) {
        //     this.Edtor.insertContent(`&#65279`);
        // }
        // if (plat == "IOS") {
        document.getElementById('Editor_box').scrollTop = top
        // }
        this.focus()
        this.scrollTop_y()
        this.setEditorHtight()
        this.getEditItem()
    },
    //获取整个论文的html
    getHtml() {
        // this.setdivContent()
        // var t = this.editors.document.getElementById('tinymce').innerText
        // var patt1 = new RegExp(/\s+/g);
        // if (patt1.test(t) && t.length == 1) {
        //     this.editors.document.getElementById('tinymce').innerHTML = '<p divcontent="divContent"><br data-mce-bogus="1"></p>'
        // }
        //  console.log(tinymce.activeEditor.getContent())
        return tinymce.activeEditor.getContent()
    },
    setdivContent() {
        tinymce.activeEditor.undoManager.transact(() => {
            var dom = this.editors.document.getElementById("tinymce").children;
            for (var i = 0; i < dom.length; i++) {
                console.log(dom[i].localName)
                if (dom[i].localName == "p") {
                    dom[i].setAttribute("divcontent", 'divcontent');
                }
            }
        })

    },
    // 获取论文标题
    getWritingTitle() {
        return document.getElementById('W_title').value
    },
    titlelist: [],
    //获取论文提纲标题
    getTexttitle() {
        var dom = this.editors.document.getElementById("tinymce").children;
        this.titlelist = [];
        var _this = this
        tinymce.activeEditor.undoManager.ignore(function () {
            let titleid = 0
            for (var i = 0; i < dom.length; i++) {
                if (
                    dom[i].localName == "h1" ||
                    dom[i].localName == "h2" ||
                    dom[i].localName == "h3" ||
                    dom[i].localName == "h4" ||
                    dom[i].localName == "h5" ||
                    dom[i].localName == "h6"
                ) {
                    dom[i].setAttribute('id', i)
                    titleid = i
                    if (dom[i].innerText.length > 0) {
                        _this.titlelist.push({
                            localName: dom[i].localName,
                            id: i,
                            content: dom[i].innerText
                        });
                    } else {
                        _this.titlelist.push({
                            localName: dom[i].localName,
                            id: i,

                            content: "未命名标题"
                        });
                    }
                }

                dom[i].setAttribute("title-id", titleid);

                if (i == (dom.length - 1)) {
                    var titles = _this.titlelist
                    return JSON.stringify(titles)
                }
            }
        });
        return JSON.stringify(this.titlelist)
    },
    //设置标题id  内容titleid
    setid() {
        var dom = this.editors.document.getElementById("tinymce").children;
        let titleid = 0
        tinymce.activeEditor.undoManager.ignore(function () {
            if (tinymce.activeEditor.selection.isCollapsed() === false) {
                tinymce.execCommand('delete');
            }
            for (var i = 0; i < dom.length; i++) {
                if (
                    dom[i].localName == "h1" ||
                    dom[i].localName == "h2" ||
                    dom[i].localName == "h3" ||
                    dom[i].localName == "h4" ||
                    dom[i].localName == "h5" ||
                    dom[i].localName == "h6"
                ) {
                    dom[i].setAttribute('id', i)
                    titleid = i
                }
                dom[i].setAttribute("title-id", titleid);

            }
        });
        tinymce.execCommand('undo')


    },
    content: '',
    contents: '',
    titleid: '',
    localName: '',
    getTextContent() {
        var dom = this.editors.document.getElementById("tinymce").children;
        var p_content = ''
        var contentArr = []
        for (var i = 0; i < dom.length; i++) {
            if (
                dom[i].localName == "p"
            ) {
                if (dom[i].innerHTML == '<br>') {
                    continue;
                }
                p_content += dom[i].innerText
                p_content += '&nbsp;'
            }

        }
        return p_content
    },
    demos() {
        console.log(this.getTextContent())
    },
    /**
     * 获取推荐思路内容
     */
    getContent() {
        this.getTexttitle()
        this.focusOffset = this.editors.document.getSelection().baseOffset;
        if (!this.editors.getSelection().focusNode) {
            return false;
        }
        this.localName = this.editors.document.queryCommandValue("formatBlock");
        this.titleid = tinymce.activeEditor.selection
            .getSelectedBlocks()[0]
            .getAttribute("title-id");
        this.content = this.editors.getSelection().focusNode;
        if (
            this.localName != "h1" &&
            this.localName != "h2" &&
            this.localName != "h3" &&
            this.localName != "h4" &&
            this.localName != "h5" &&
            this.localName != "h6"
        ) {

            this.contents = "";
            if (this.content.textContent.length != 0) {
                this.contents = this.content.textContent.slice(0, this.focusOffset);
            }
            // if (this.content.textContent.length == 0) {
            //     if (!this.content.previousSibling) {
            //         this.contents = "";
            //     } else {
            //         if (
            //             this.content.previousSibling.innerText.length != 0 &&
            //             this.content.previousSibling.innerHTML != "<br>"
            //         ) {
            //             this.contents = this.content.previousSibling.innerText;
            //             this.localName = this.content.previousSibling.localName;
            //         } else {
            //             this.getContentVal(this.content.previousSibling);
            //         }
            //     }
            // }
            this.focus()
            let contentData = {
                id: this.titleid,
                onTitle: false,
                content: this.contents
            }
            return JSON.stringify(contentData)
        } else {
            this.titleid = tinymce.activeEditor.selection
                .getSelectedBlocks()[0]
                .getAttribute("id")
            if (this.content.textContent.length != 0) {
                this.contents = this.content.textContent.slice(0, this.focusOffset);
            }
            let contentData = {
                id: this.titleid,
                onTitle: true,
                content: ''
            }
            return JSON.stringify(contentData)
        }

    },
    //清空重做撤销 第一次进来页面还原数据的时候使用
    clearUndoManager() {
        tinymce.activeEditor.undoManager.clear();
        tinymce.activeEditor.undoManager.transact(function () {
            tinymce.execCommand("undo");
        });
        tinymce.activeEditor.insertContent('&#65279')
        tinymce.execCommand("undo");

    },
    // 获取章节id
    getTitleID(dom) {
        if (dom.parentNode.localName == 'p') {
            this.titleid = dom.parentNode.getAttribute('title-id')
        } else {
            this.getTitleID(dom.parentNode.parentNode)
        }
    },
    //获取编辑器推荐思路需要对内容
    getContentVal(dom) {
        if (!dom.previousSibling) {
            this.contents = this.edit_title;
            this.localName = "";
            return false;
        }
        var tag_name = dom.localName
        if (tag_name == "h1" &&
            tag_name == "h2" &&
            tag_name == "h3" &&
            tag_name == "h4" &&
            tag_name == "h5" &&
            tag_name == "h6") {
        } else {
            this.getContentVal(dom.previousSibling);
        }
    },
    getItem: "",
    hasUndo: false,//获取当前是否可以撤销对状态 true为可以撤销
    hasRedo: false,//获取当前是否可以重做对状态 true为可以重做
    acvArray: [],//获取的所有状态都在这里面
    fontColorval: '',
    sizeVal: '',
    fontSizenum: '',

    /**
  * 获取当前的所有状态
  * @param {*} evt
  */
    getEditItem() {
        var _self = this;
        var _self$schemeCache = _self.schemeCache,
            STATE_SCHEME = _self$schemeCache.STATE_SCHEME;
        //通过点击时，去获得一个当前位置的所有状态 
        this.hasUndo = this.Edtor.undoManager.hasUndo();
        this.hasRedo = this.Edtor.undoManager.hasRedo();
        clearTimeout(this.getlitertime);
        // this.getlitertime = setTimeout(() => {
        //     // this.getliterdom();
        //     //  this.saveWritingData()
        // }, 500);
        clearTimeout(this.getItem);
        this.getItem = setTimeout(() => {
            _self.acvArray = [];
            _self.queryArray.forEach(function (item) {
                if (_self.editors.document.queryCommandState(item)) {
                    _self.acvArray.push(item);
                }
            });
            var block = tinymce.activeEditor.selection.getSelectedBlocks()[0];
            //获取是否是标题
            if (_self.editors.document.queryCommandValue("formatBlock")) {
                _self.acvArray.push(_self.editors.document.queryCommandValue("formatBlock"));
            } else {
                _self.acvArray.push("div");
            }

            //获取字体名称   
            let dom = _self.editors.document.getSelection().focusNode.parentNode

            if (
                _self.acvArray.indexOf("insertOrderedList") != -1 ||
                _self.acvArray.indexOf("insertUnorderedList") != -1
            ) {
                let type = block.getAttribute("class") || block.parentNode.getAttribute("class")

                this.acvArray.push('listtype_' + type)
            }
            if (dom.style.borderBottomWidth == "1px") {
                _self.acvArray.push("underline");
            }
            //获取文字颜色
            var rgb = _self.editors.document.queryCommandValue("foreColor");
            this.acvArray.push("fontcolor_" + _self.editors.document.queryCommandValue("foreColor"))
            if (dom.style.backgroundColor != "") {
                let bgcolor = dom.style.backgroundColor
                    .split("(")[1]
                    .split(")")[0]
                    .split(",");
                this.acvArray.push("bgcolor_" + bgcolor)
            } else {
                this.acvArray.push("bgcolor_rgb(255, 255, 255)")
            }
            this.acvArray.push("fontName_" + tinymce.activeEditor.queryCommandValue("fontName"))
            this.acvArray.push("lineHeight_" + tinymce.activeEditor.queryCommandValue("LineHeight"))


            this.acvArray.push("size_" + tinymce.activeEditor.queryCommandValue("fontSize"))
            this.acvArray.push('hasUndo_' + this.hasUndo)
            this.acvArray.push('hasRedo_' + this.hasRedo)
            if (plat == "android") {
                //这里调用android暴露出来对方法
                window.androidJs.onTextState(JSON.stringify(_self.acvArray.join('&')))
            }
            if (plat == "IOS") {
                //这里调用IOS里面暴露出来对方法  
                window.webkit.messageHandlers.onTextState.postMessage(JSON.stringify(_self.acvArray.join('&')));
            }

        }, 100);
    },
    exundo(tag) {
        tinymce.activeEditor.execCommand(tag)
    },
    /**
  * 颜色转16进制
  */
    colors(arr) {
        var color = "#";
        arr.forEach((item) => {
            color += Number(item).toString(16);
            if (Number(item).toString(16) == 0) {
                color += 0;
            }
        });
        return color;
    },

    gethtml: "",
    //重置引用序号
    getliterdom() {
        clearTimeout(this.gethtml);
        this.gethtml = setTimeout(() => {
            let domList = this.editors.document.querySelectorAll(".liters");
            domList.forEach((item, index) => {
                item.innerHTML = `[${index + 1}]`;
            });
            if (domList.length == 0) {
                return false;
            }
            let ids = [];
            for (let i = 0; i < domList.length; i++) {
                if (ids.indexOf(domList[i].getAttribute("data-index")) == -1) {
                    ids.push(domList[i].getAttribute("data-index"));
                }
            }
        }, 1000);
    },
    //获取当前是否在标题上
    focusState() {
        let onTitle = false
        if (this.editors.document.queryCommandValue("formatBlock") != 'p') {
            onTitle = true
        }
        return onTitle
    },
    //设置键盘高度
    setBlurBord(num) {
        this.keyboarheight = num
    },
    /**
     * 插入字符
     */
    insertContent(items) {
        //  var items = ` 本文以钱钱财请求为研究对象,主要从钱物权与金钱请求的关系、权利和义务以及如何进行司法审查等方面来分析。首先对资金所有权和使用权展开了理论概述。然后通过比较法将国内外关于出资法律制度相关文献做一个对比。最后在结合我国实际情况提出问题并加以解释说明;其次是针对当前社会上存在的不同名目诈骗案件做出具体分析,并且给出相应解决措施与建议:完善反垄断立法及监管体系、加强行业自律性管理等来解决问题;`
        let top = document.documentElement.scrollTop || document.body.scrollTop
        tinymce.activeEditor.insertContent(items);
        this.setEditorHtight()

        this.scrollTop_y()
        if (plat == 'android') {
            //         document.documentElement.scrollTop=top-300
            //                document.body.scrollTop.top= top-300
        }


        this.saveWritingData()
    },
    /**
     * 插入内容
     */
    setHtml(items) {
        this.Edtor.insertContent(items);
    },
    //初始化调用的添加内容方式
    addHtml(html) {
        //  var html = `<h1>第1章 绪论</h1> <p divContent="divContent"> <img id="img1" style="max-width: 100%" src="https://ai-write.oss-cn-hangzhou.aliyuncs.com//article-img/dbf04ac4-ecdc-4db8-84eb-db6e05b8a9af.jpeg?1614836551379" /></p><p><br></p><p><br></p><p><br></p><p><br></p><p><br></p><p><br></p><p>1.1 研究背景</p><p>1.2 国内外相关文献回顾</p><p>1.3 研究方法</p><p>1.4 研究框架</p><div id="divContent"><br></div><h1>第2章 国内外研究综述</h1><p>2.1 公共交通理论</p><p>2.2 国外公共交通的研究与实践</p><p>2.3 本章小结</p><div id="divContent"><br></div><h1>第3章 公共交通的特征分析</h1><p>3.1 公共交通的基本内涵</p><p>3.2 公共交通的构成要素</p><p>3.3 公共交通的作用</p><p>3.4 公共交通竞争</p><div id="divContent"><br></div><h1>第4章 公共交通影响因素评价</h1><p>4.1 公共交通影响指标体系</p><p>4.2 公交换乘影响因素权重确定</p><p>4.3 评价结果及讨论</p><div id="divContent"><br></div><h1>第5章 交通发展对策</h1><p>5.1 交通管理中的政府</p><p>5.2 提高公共交通服务水平</p><p>5.3 加强公共交通基础设施</p><h2>5.4 公共交通保障</h2><div id="divContent"><br></div><h1>第6章 结束语</h1>`
        let _this = this
        tinymce.activeEditor.undoManager.transact(function () {
            _this.editors.document.getElementById('tinymce').innerHTML = html
            //tinymce.activeEditor.insertContent(html);
            _this.getTexttitle()
            _this.setEditorHtight()
            _this.blur()
            console.log(_this.editors.document)
            // setTimeout(() => {
            //     _this.initListener()
            // }, 100);
        })
    }
}
checkPlatform()
Re.adinit()
